#include <iostream>
#include <string>

using namespace std;

class Persona {	
protected:
  string nome;
public: 
    Persona(string s);
    virtual void print() { cout << "Il mio nome e' " << nome << endl; }//interfaccia virtuale comune a tutte le future classi derivate

};

Persona::Persona(string s)
{
	this->nome=s;
}


class Studente : public Persona {
private:
  float media;
public: 
  Studente(string s, float g) : Persona(s),media(g) { } //lista di inizializzazione
  void print() { cout << "Il mio nome e' " << nome
     << " e la mia media e' " << media << endl; } //catena di derivazione deve essere pubblica OVERRIDE

};


class Professore : public Persona {
private:
  int pubblicazioni;
public: 
  Professore(string s, int n) : Persona(s), pubblicazioni(n) { }//lista di inizializzazione
  void print() { cout << "Il mio nome e' " << nome
     << " ed ho  " << pubblicazioni << " pubblicazioni" << endl; }//OVERRIDE

};

int main()
{
  Persona* p;
  Persona x(string("Giuseppe"));
  p = &x;
  p->print();
  x.print();
  Studente y(string("Giovanni"), 21.);
  p = &y;
  p->print();
  y.print();
  Professore z(string("Antonio"), 7);
  p = &z;
  p->print();  
  z.print();
  return 0;
}
